import { getConfig } from './config.js';
var clientId;
export var loadScript = function loadScript(src) {
  return new Promise(function (resolve, reject) {
    var s = document.createElement('script');
    s.src = src;
    s.onload = resolve;
    s.onerror = reject;
    document.head.appendChild(s);
  });
};
export var getGoogleClientID = function getGoogleClientID() {
  var googleAnalyticsMeasurementId = getConfig('googleAnalyticsMeasurementId'); // 1. Check we have the needed config to load the script

  if (!googleAnalyticsMeasurementId) return Promise.resolve(false); // 2. Check we have already a clientId stored

  if (clientId) return Promise.resolve(clientId); // 3. Load Gtag and retrieve async clientId from Google

  var gtagScript = "https://www.googletagmanager.com/gtag/js?id=" + googleAnalyticsMeasurementId;
  return new Promise(function (resolve) {
    loadScript(gtagScript).then(function () {
      return window.gtag == null ? void 0 : window.gtag('get', googleAnalyticsMeasurementId, 'client_id', function (remoteClientId) {
        // store locally clientId
        clientId = remoteClientId; // resolve the promise with the clientId

        resolve(remoteClientId);
      });
    })["catch"](function (e) {
      console.error('Error loading gtag for Segment');
    });
  });
};